config/routes.rb
Rails.application.routes.draw do
  resources :purchases
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Defines the root path route ("/")
  # root "articles#index"
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/purchase.rb
class Purchase < ApplicationRecord
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/purchases_controller.rb
class PurchasesController < ApplicationController
  before_action :set_purchase, only: %i[ show edit update destroy ]

  # GET /purchases or /purchases.json
  def index
    @purchases = Purchase.all
  end

  # GET /purchases/1 or /purchases/1.json
  def show
  end

  # GET /purchases/new
  def new
    @purchase = Purchase.new
  end

  # GET /purchases/1/edit
  def edit
  end

  # POST /purchases or /purchases.json
  def create
    @purchase = Purchase.new(purchase_params)

    respond_to do |format|
      if @purchase.save
        format.html { redirect_to purchase_url(@purchase), notice: "Purchase was successfully created." }
        format.json { render :show, status: :created, location: @purchase }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @purchase.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /purchases/1 or /purchases/1.json
  def update
    respond_to do |format|
      if @purchase.update(purchase_params)
        format.html { redirect_to purchase_url(@purchase), notice: "Purchase was successfully updated." }
        format.json { render :show, status: :ok, location: @purchase }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @purchase.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /purchases/1 or /purchases/1.json
  def destroy
    @purchase.destroy

    respond_to do |format|
      format.html { redirect_to purchases_url, notice: "Purchase was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_purchase
      @purchase = Purchase.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def purchase_params
      params.require(:purchase).permit(:name, :cost)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/purchases_helper.rb
module PurchasesHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>App</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
    <%= javascript_importmap_tags %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

app/views/purchases/_form.html.erb
<%= form_with(model: purchase) do |form| %>
  <% if purchase.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(purchase.errors.count, "error") %> prohibited this purchase from being saved:</h2>

      <ul>
        <% purchase.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div>
    <%= form.label :name, style: "display: block" %>
    <%= form.text_field :name %>
  </div>

  <div>
    <%= form.label :cost, style: "display: block" %>
    <%= form.text_field :cost %>
  </div>

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/purchases/_purchase.html.erb
<div id="<%= dom_id purchase %>">
  <p>
    <strong>Name:</strong>
    <%= purchase.name %>
  </p>

  <p>
    <strong>Cost:</strong>
    <%= purchase.cost %>
  </p>

</div>

app/views/purchases/edit.html.erb
<h1>Editing purchase</h1>

<%= render "form", purchase: @purchase %>

<br>

<div>
  <%= link_to "Show this purchase", @purchase %> |
  <%= link_to "Back to purchases", purchases_path %>
</div>

app/views/purchases/index.html.erb
<p style="color: green"><%= notice %></p>

<h1>Purchases</h1>

<div id="purchases">
  <% @purchases.each do |purchase| %>
    <%= render purchase %>
    <p>
      <%= link_to "Show this purchase", purchase %>
    </p>
  <% end %>
</div>

<%= link_to "New purchase", new_purchase_path %>

app/views/purchases/new.html.erb
<h1>New purchase</h1>

<%= render "form", purchase: @purchase %>

<br>

<div>
  <%= link_to "Back to purchases", purchases_path %>
</div>

app/views/purchases/show.html.erb
<p style="color: green"><%= notice %></p>

<%= render @purchase %>

<div>
  <%= link_to "Edit this purchase", edit_purchase_path(@purchase) %> |
  <%= link_to "Back to purchases", purchases_path %>

  <%= button_to "Destroy this purchase", @purchase, method: :delete %>
</div>